# Glances: un htop en python
![category](autre)
![tag](supervision)
![tag](utilitaire)

Glances est un outil écrit en python qui permet de remplacer avantageuseument htop

Le principe est le suivant:

- un serveur glances est lancé sur une machine
- un client affiche le résultat

On peut donc suivre un htop d'un serveur distant 

Il permet de gérer 

- cpu, mémoire, processus, ...
- réseau (lan, wifi, ...)
- battery
- container docker
- emission d'alerte
- ...

De plus il peut renvoyer les informations collecter aussi bien sur un client
que sur

- rabbitmq
- grafana
- client RPC
- alerte mail
- ...


Installation
------------

On utilise pip

```bash
pip install glances

```

```warning
il faut bien vérifier la version de psutil qui va être installé ...
il faut une version 5.1 au minimum. On peut le vérifier par un

.. code-block:: bash

    glances --version

```

```warning
Au moment ou j'écris l'installation ne fonctionne pas sous *Termux*
En effet le module psutil ne fonctionne pas

```

Utilisation sous windows
------------------------

Glances fonctionnant sous curses, par défaut sous windows seul le serveur et le 
client web fonctionne.

On peut comme même utiliser via la console en réalisant quelques modifications

- installation ncurse pour windows via l'url http://www.lfd.uci.edu/~gohlke/pythonlibs/#curses

```bash
pip install xxxx.whl
```

- modifier le fichier glances/output/glances_curses.py à la ligne 33

```python
if not WINDOWS or WINDOWS:
```

- modifier le fichier glances/output/glances_curses.py à la ligne 999 (fonction get_stats_display_width)

```python
return c + 1
```

- modifier glances/__init__.py en ajoutant à la dernière ligne

```python
start_client(config=config, args=args)

```

Puis lancer le client de la façon suivante

```bash
glances -c 127.0.0.1

```

```note
pour sortir de glances il faut appuyer sur ECHAP
```

Utilisation sous raspberry
--------------------------

Au moment que j'écris il existe un bug facilement contournable

on modifie /usr/local/lib/python3.4/dist-packages/glances/plugins/glances_irq.py ... ligne 181
ainsi

```python
splitted_line = self.cpu_number > len(line.split()) and [0,] or line.split()

```

Création d'un sevice glances
----------------------------

Sous Linux
~~~~~~~~~~

Sous Debian il existe deux possibilités:

- copier le fichier /etc/init.d/skeleton en /etc/init.d/glances puis configurer ce dernier
- installer le package glances puis paramétrer le fichier /etc/default/glances (mettre true)

```bash
pip3 install glances
apt-get install glances
rm /usr/bin/glances
ln -s /usr/local/bin/glances /usr/bin/glances

```

```note
personnellement je modifie le paramètre DAEMON_ARGS de /etc/init.d/glances
afin de ne garder que le "-s" (je ne veux pas d'une conf spécifique)
cela nécessite alors un rechargement de daemons

.. code-block:: bash

    systemctl daemon-reload
```

Sous Windows
~~~~~~~~~~~~

Le plus simple est de faire une tâche planifié qui aura pour déclencheur le
demarrage de la machine.

Sous android
------------

avec **Termux**

```bash
apt update
apt upgrade
apt install clang python python-dev
pip install glances
glances
```

Utilisation de grafana
----------------------

toutes les infos sur la doc officiels http://glances.readthedocs.io/en/stable/gw/influxdb.html#grafana

Activer docker sous windows
---------------------------

Au moment que j'écris, glances ne collecte pas d'info docker sous un serveur windows.
J'ai proposé un "pull request" corrigeant ce problème

Dans le fichier plugin glance_docker.py il faut ajouter

```python
from glances.globals import WINDOWS
...

def _connect_old(...
...
    if WINDOWS:
        url = 'npipe:////./pipe/docker_engine'
    else:
        url = 'unix://var/run/docker.sock'
    if version is None:
        ret = init_docker(base_url=url)
    else:
        ret = init_docker(base_url=url,
                 version=version)
```
